// WebInterface.h

#ifndef _WEBINTERFACE_H
#define _WEBINTERFACE_H

//root page
const char switching_html[] PROGMEM = R"rawliteral(
  <!DOCTYPE HTML>
    <html>
      <head>
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>RELAY BOARD</title>
        <link rel="icon" href="data:,">
        <style>
          body {
            background: #333333;
            color: #AAAAAA;
            font-family: Lucida,monospace;
            text-align: center;
            line-height: 1.25em;
          }
          a {
            color: #777777;
            text-decoration: none;
          }
          a:hover {
            color: #AAAAAA;
          }
          a:focus {
            color: #AAAAAA;
          }
          .space-output {
            font-size: 0.7em;
          }
          .space-left {
            line-height: 1.4em;
          }
          .base {
            color: #777777;
            font-size: 0.75em;
            line-height: 2.25em;
          }
          .div-main {
          }
          .div-left {
            float: left;
            width: 50%;
          }
          .div-right {
            float: right;
            width: 50%;
          }
          .input {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #3F3F3F;
            appearance: none;
            -webkit-appearance: none;
          }
          .input:hover {
            border: 0.15em solid #AAAAAA;
          }
          .input:focus {
            border: 0.15em solid #AAAAAA;
          }
          .output {
            height: 1.0em;
            width: 3.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #3F3F3F;
            text-align: center;
            appearance: none;
            -webkit-appearance: none;
          }
          .button-false {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #000066;
            appearance: none;
            -webkit-appearance: none;
          }
          .button-true {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #1919FF;
            appearance: none;
            -webkit-appearance: none;
          }
          .relay-false {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #660000;
            appearance: none;
            -webkit-appearance: none;
          }
          .relay-false:hover {
            border: 0.15em solid #AAAAAA;
          }
          .relay-false:focus {
            border: 0.15em solid #AAAAAA;
          }
          .relay-true {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #CC0000;
            appearance: none;
            -webkit-appearance: none;
          }
          .relay-true:hover {
            border: 0.15em solid #AAAAAA;
          }
          .relay-true:focus {
            border: 0.15em solid #AAAAAA;
          }
          .group-false {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #49002b;
            appearance: none;
            -webkit-appearance: none;
          }
          .group-true {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #97025a;
            appearance: none;
            -webkit-appearance: none;
          }
        </style>
      </head>
      <body>
        <script>
          //client ID int
          var clientID = 0;
          //state arrays
          var stateButton = [];  //button state array with ints
          var stateRelay = [];  //relay state array with ints
          var groupButton = [];  //button groups assignment array with ints
          var groupRelay = [];  //relay group assignment array with strings
          //amount ints
          var amountButton;
          var amountRelay;
          var amountGroupButton;
          var amountGroupRelay;
          //message object
          var websocketMessage = "";
          //gateways and objects
          var gateway = `ws://${window.location.hostname}/websocket`;
          var websocket;
          //event listener
          window.addEventListener('load', onLoad);
          function initWebSocket() {
            console.log('connection:wait');
            websocket = new WebSocket(gateway);
            websocket.onopen    = onOpen;  //websocket connection opened
            websocket.onclose   = onClose;  //websocket connection closed
            websocket.onmessage = onMessage;  //websocket message
          }
          //websocket events
          function onLoad(event) {  //page loaded
            initWebSocket();
          }
          function onOpen(event) {  //websocket connection opened
            console.log('connection:true');
            if (websocketMessage != "") {
              message(websocketMessage);
            }
          }
          function onClose(event) {  //websocket connection closed
            console.log('connection:false');
            setTimeout(initWebSocket, 250);
          }
          function onMessage(event) {  //websocket message
            console.log(event.data);
            if ((event.data).startsWith("clientID:#")) {
              clientID = parseInt((event.data).substring(10));
            }
            if ((event.data).startsWith("buttonState:")) {
              var data = (event.data).substring(12);
              amountButton = data.length;
              for (let i=0;i<amountButton;i++) {
                stateButton[i] = parseInt(data[i]);
              }
            }
            else if ((event.data).startsWith("relayState:")) {
              var data = (event.data).substring(11);
              amountRelay = data.length;
              for (let i=0;i<amountRelay;i++) {
                stateRelay[i] = parseInt(data[i]);
              }
            }
            else if ((event.data).startsWith("buttonGroup:")) {
              var data = (event.data).substring(12);
              amountGroupButton = (data.split("/")).length;
              var dataSplit = data.split("/");
              for (let i=0;i<amountGroupButton;i++) {
                groupButton[i] = parseInt(dataSplit[i].split(":")[1]);
              }
            }
            else if ((event.data).startsWith("relayGroup:")) {
              var data = (event.data).substring(11);
              amountGroupRelay = (data.split("/")).length;
              var dataSplit = data.split("/");
              for (let i=0;i<amountGroupRelay;i++) {
                groupRelay[i] = dataSplit[i].split(":")[1];
              }
            }
            else if ((event.data).startsWith("groupChangeButton:")) {
              var dataSplit = ((event.data).substring(18)).split(":");
              groupButton[parseInt(dataSplit[0]) - 1] = parseInt(dataSplit[1]);
            }
            else if ((event.data).startsWith("groupChangeRelay:")) {
              var dataSplit = ((event.data).substring(17)).split(":");
              groupRelay[parseInt(dataSplit[0])] = dataSplit[1];
            }
            else if ((event.data).startsWith("websocketData")) {
              websocketMessage = "";
            }
            stateUpdate();
          }
          function stateUpdate() {
            displayButton();
            displayRelay();
            displayGroupButton();
            displayGroupRelay();
            var amountSpaceLeft = amountGroupRelay - amountRelay - 2;
            var spaceSpaceLeft = "";
            for (let i=0;i<amountSpaceLeft;i++) {
              spaceSpaceLeft += "<br>";
            }
            var base = `[client #${clientID}]&nbsp;&nbsp;&nbsp;[${window.location.hostname + window.location.pathname}]&nbsp;&nbsp;&nbsp;[<a href="/settings">settings</a>]`;
            document.getElementById("spaceLeft").innerHTML = spaceSpaceLeft;
            document.getElementById("base").innerHTML = base;
          }
          function displayButton() {
            var buttonSub = "";
            for (let i=0;i<amountButton;i++) {
              var spaceNumber = "&nbsp;";
              var color = "button-false";
              var state = "";
              if (i + 1 < 10) {
                spaceNumber = "&nbsp;&nbsp;";
              }
              if (stateButton[i]) {
                color = "button-true";
                state = " checked";
              }
              buttonSub += `button${spaceNumber}#${i + 1}&nbsp;<input type="checkbox" class="${color}" onClick=""${state} disabled>&nbsp;&nbsp;&nbsp;<br>`;
            }
            document.getElementById("contentButton").innerHTML = buttonSub;
          }
          function displayRelay() {
            var relaySub = "";
            for (let i=0;i<amountRelay;i++) {
              var spaceNumber = "&nbsp;&nbsp;";
              var color = "relay-false";
              var state = "";
              if (i + 1 < 10) {
                spaceNumber = "&nbsp;&nbsp;&nbsp;";
              }
              if (stateRelay[i]) {
                color = "relay-true";
                state = " checked";
              }
              relaySub += `relay${spaceNumber}#${i + 1}&nbsp;<input type="checkbox" class="${color}" onClick="change(${i + 1},'t')"${state}>&nbsp;<button type="button" class="input" onClick="change(${i + 1},'p')"></button><br>`;
            }
            document.getElementById("contentRelay").innerHTML = relaySub;
          }
          function displayGroupButton() {
            var groupButtonSub = "";
            for (let i=0;i<amountButton;i++) {
              var spaceNumber = "&nbsp;";
              var spaceValue = ""
              var spaceEnd = ("&nbsp").repeat(amountRelay * 2);
              if (i + 1 < 10) {
                spaceNumber = "&nbsp;&nbsp;";
              }
              if (groupButton[i] < 10) {
                spaceValue = "&nbsp;";
              }
              groupButtonSub += `button${spaceNumber}#${i + 1}<span class="space-output">&nbsp;&nbsp;</span><input type="text" class="output" value="${groupButton[i]}" disabled>${spaceEnd}<br>`;
            }
            document.getElementById("contentGroupButton").innerHTML = groupButtonSub;
          }
          function displayGroupRelay() {
            var groupRelaySub = "";
            for (let i=0;i<amountGroupRelay;i++) {
              var spaceNumber = "&nbsp;&nbsp;";
              if (i < 10) {
                spaceNumber = "&nbsp;&nbsp;&nbsp;";
              }
              groupRelaySubSub = ""
              for (let j=0; j<amountRelay;j++) {
                var color = "group-false";
                if (parseInt((groupRelay[i])[j])) {
                  color = "group-true";
                }
                groupRelaySubSub += `<input type="checkbox" class="${color}" onClick="">`;
              }
              groupRelaySub += `group${spaceNumber}#${i}&nbsp;${groupRelaySubSub}&nbsp;<button type="button" class="input" onClick="change(${i},'g')"></button><br>`;
            }
            document.getElementById("contentGroupRelay").innerHTML = groupRelaySub;
          }
          function change(number, mode) {  //relay changes and group selects
            if (mode == "t" || mode == "p") {
              websocketMessage = `relay:${number}:${mode}`;
            }
            else if (mode == "g") {
              websocketMessage = `group:get:${number}`;
            }
            message(websocketMessage);
          }
          function message(message) {  //send message over websocket
            websocket.send(message);
          }
        </script>
        <!--html page stuff-->
        <div class="div-main">
        <h1>RELAY BOARD</h1>
          <div class="div-left">
            <form id="contentButton">
              ...loading buttons!
            </form>
            <br>
            <form id="contentRelay">
              ...loading relays!
            </form>
            <br>
            <span id="spaceLeft" class="space-left">
            </span>
            <span id="base" class="base">
            </span>
          </div>
          <div class="div-right">
            <form id="contentGroupButton">
              ...loading button groups!
            </form>
            <br>
            <form id="contentGroupRelay">
              ...loading relay groups!
            </form>
          </div>
        </div>
      </body>
    </html>
  )rawliteral";

//settings page
const char settings_html[] PROGMEM = R"rawliteral(  
  <!DOCTYPE HTML>
    <html>
      <head>
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>RELAY BOARD</title>
        <link rel="icon" href="data:,">
        <style>
          body {
            background: #333333;
            color: #AAAAAA;
            font-family: Lucida,monospace;
            text-align: center;
            line-height: 1.25em;
          }
          a {
            color: #777777;
            text-decoration: none;
          }
          a:hover {
            color: #AAAAAA;
          }
          a:focus {
            color: #AAAAAA;
          }
          .space-output {
            font-size: 0.7em;
          }
          .base {
            color: #777777;
            font-size: 0.75em;
            line-height: 2.25em;
          }
          .div-main {
          }
          .div-center {
            float: left;
            width: 100%;
          }
          .input {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #3F3F3F;
            appearance: none;
            -webkit-appearance: none;
          }
          .input:hover {
            border: 0.15em solid #AAAAAA;
          }
          .input:focus {
            border: 0.15em solid #AAAAAA;
          }
          .input-change {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #e27400;
            appearance: none;
            -webkit-appearance: none;
          }
          .input-change:hover {
            border: 0.15em solid #AAAAAA;
          }
          .input-change:focus {
            border: 0.15em solid #AAAAAA;
          }
          .output {
            height: 1.5em;
            width: 3.75em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #3F3F3F;
            color: #AAAAAA;
            text-align: center;
            appearance: none;
            -webkit-appearance: none;
          }
          .output:hover {
            border: 0.15em solid #AAAAAA;
          }
          .output:focus {
            border: 0.15em solid #AAAAAA;
          }
          .group {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #49002b;
            appearance: none;
            -webkit-appearance: none;
          }
          .group:checked {
            height: 1.25em;
            width: 1.25em;
            border: 0.15em solid #777777;
            border-radius: 35%;
            vertical-align: middle;
            background-color: #97025a;
            appearance: none;
            -webkit-appearance: none;
          }
          .group:hover {
            border: 0.15em solid #AAAAAA;
          }
          .group:focus {
            border: 0.15em solid #AAAAAA;
          }
        </style>
      </head>
      <body>
        <script>
          //client ID int
          var clientID = 0;
          //state arrays
          var groupButton = [];  //button groups assignment array with ints
          var groupRelay = [];  //relay group assignment array with strings
          //amount ints
          var amountButton;
          var amountRelay;
          var amountGroupButton;
          var amountGroupRelay;
          //message object
          var websocketMessage = "";
          //gateways and objects
          var gateway = `ws://${window.location.hostname}/websocket`;
          var websocket;
          //event listener
          window.addEventListener('load', onLoad);
          function initWebSocket() {
            console.log('connection:wait');
            websocket = new WebSocket(gateway);
            websocket.onopen    = onOpen;  //websocket connection opened
            websocket.onclose   = onClose;  //websocket connection closed
            websocket.onmessage = onMessage;  //websocket message
          }
          //websocket events
          function onLoad(event) {  //page loaded
            initWebSocket();
          }
          function onOpen(event) {  //websocket connection opened
            console.log('connection:true');
            if (websocketMessage != "") {
              message(websocketMessage);
            }
          }
          function onClose(event) {  //websocket connection closed
            console.log('connection:false');
            setTimeout(initWebSocket, 2500);
          }
          function onMessage(event) {  //websocket message
            var groupColorChange = -1;
            console.log(event.data);
            if ((event.data).startsWith("clientID:#")) {
              clientID = parseInt((event.data).substring(10));
            }
            if ((event.data).startsWith("buttonState:")) {
              var data = (event.data).substring(12);
              amountButton = data.length;
            }
            else if ((event.data).startsWith("relayState:")) {
              var data = (event.data).substring(11);
              amountRelay = data.length;
            }
            else if ((event.data).startsWith("buttonGroup:")) {
              var data = (event.data).substring(12);
              amountGroupButton = (data.split("/")).length;
              var dataSplit = data.split("/");
              for (let i=0;i<amountGroupButton;i++) {
                groupButton[i] = parseInt(dataSplit[i].split(":")[1]);
              }
            }
            else if ((event.data).startsWith("relayGroup:")) {
              var data = (event.data).substring(11);
              amountGroupRelay = (data.split("/")).length;
              var dataSplit = data.split("/");
              for (let i=0;i<amountGroupRelay;i++) {
                groupRelay[i] = dataSplit[i].split(":")[1];
              }
            }
            else if ((event.data).startsWith("groupChangeButton:")) {
              var dataSplit = ((event.data).substring(18)).split(":");
              groupButton[parseInt(dataSplit[0]) - 1] = parseInt(dataSplit[1]);
            }
            else if ((event.data).startsWith("groupChangeRelay:")) {
              var dataSplit = ((event.data).substring(17)).split(":");
              groupRelay[parseInt(dataSplit[0])] = dataSplit[1];
              groupColorChange = dataSplit[0];
              setTimeout(
                function() {
                  document.getElementById("groupRelay" + dataSplit[0]).className = "input";
                },
              500);
            }
            else if ((event.data).startsWith("websocketData")) {
              websocketMessage = "";
            }
            stateUpdate(groupColorChange);
          }
          function stateUpdate(groupColorChange) {
            displayGroupButton();
            displayGroupRelay();
            if (groupColorChange >= 0) {
              document.getElementById("groupRelay" + groupColorChange).className = "input-change";
            }
            var base = `[client #${clientID}]&nbsp;&nbsp;&nbsp;[${window.location.hostname + window.location.pathname}]&nbsp;&nbsp;&nbsp;[<a href="/switching">switching</a>]`;
            document.getElementById("base").innerHTML = base;
          }
          function displayGroupButton() {
            var groupButtonSub = "";
            for (let i=0;i<amountButton;i++) {
              var spaceNumber = "&nbsp;";
              var spaceValue = ""
              var spaceEnd = ("&nbsp").repeat(amountRelay * 2);
              if (i + 1 < 10) {
                spaceNumber = "&nbsp;&nbsp;";
              }
              if (groupButton[i] < 10) {
                spaceValue = "&nbsp;";
              }
              var groupButtonSubSub = "";
              for (let j=0;j<amountGroupRelay;j++) {
                selection = "";
                if (j == groupButton[i]) {
                  selection = ` selected="selected"`
                }
                groupButtonSubSub += `<option${selection}>${j}</option>`;
              } 
              groupButtonSub += `button${spaceNumber}#${i + 1}<span class="space-output">&nbsp;&nbsp;</span><select id="groupButton${i + 1}" class="output" value="${groupButton[i]}" onchange="change(${i + 1}, 'b')">${groupButtonSubSub}</select>${spaceEnd}<br>`;
            }
            document.getElementById("contentGroupButton").innerHTML = groupButtonSub;
          }
          function displayGroupRelay() {
            var groupRelaySub = "";
            for (let i=0;i<amountGroupRelay;i++) {
              var spaceNumber = "&nbsp;&nbsp;";
              if (i < 10) {
                spaceNumber = "&nbsp;&nbsp;&nbsp;";
              }
              groupRelaySubSub = ""
              for (let j=0; j<amountRelay;j++) {
                var check = "";
                if (parseInt((groupRelay[i])[j])) {
                  check = " checked";
                }
                groupRelaySubSub += `<input type="checkbox" id="groupRelay${i}.${j + 1}" class="group" onClick=""${check}>`;
              }
              groupRelaySub += `group${spaceNumber}#${i}&nbsp;${groupRelaySubSub}&nbsp;<button type="button" id="groupRelay${i}" class="input" onClick="change(${i},'g')"></button><br>`;
            }
            document.getElementById("contentGroupRelay").innerHTML = groupRelaySub;
          }
          function change(number, mode) {  //relay changes and group selects
            if (mode == "b") {
              websocketMessage = `button:${number}:${document.getElementById("groupButton" + number).value}`;
            }
            else if (mode == "g") {
              var setting = ""
              for (let i=0;i<amountRelay;i++) {
                if (document.getElementById(`groupRelay${number}.${i + 1}`).checked) {
                  setting += "1";
                }
                else {
                  setting += "0";
                }
              }
              websocketMessage = `group:set:${number}:${setting}`;
            }
            message(websocketMessage);
          }
          function message(message) {  //send message over websocket
            websocket.send(message);
          }
        </script>
        <!--html page stuff-->
        <div class="div-main">
        <h1>RELAY BOARD</h1>
          <div class="div-center">
            <form id="contentGroupButton">
              ...loading button groups!
            </form>
            <br>
            <form id="contentGroupRelay">
              ...loading relay groups!
            </form>
            <br>
            <span id="base" class="base">
            </span>
          </div>
        </div>
      </body>
    </html>
  )rawliteral";

#endif  // _WEBINTERFACE_H